<?php

/*
  
  File: message.php3
  $Author: chuck $
  $Revision: 2.23.2.21 $
  $Date: 2000/01/09 19:58:16 $
  
  IMP: Copyright 1998, 1999 Charles J. Hagenbuch <chuck@horde.org>
  
  You should have received a copy of the GNU Public
  License along with this package; if not, write to the
  Free Software Foundation, Inc., 59 Temple Place - Suite 330,
  Boston, MA 02111-1307, USA.
  
*/

function add_attachment ($mime, $ref) {
  global $atc, $lang;
  if ($mime->name == '') { $mime->name = $lang->attachment . ' ' . $ref; }
  if ($mime->size != 0) {
    if (!isset($atc)) $atc = '';
    $atc .= $mime->display();
  }
}

function messageRange ($arr, $index, $offset, $beginIndex) {
  $count = 200; // maybe make this configurable later
  $half = $count/2;
  
  if ($index < $half)
    $start = 0;
  else if (($index + $count) >= count($arr))
    $start = max(0, count($arr) - $count);
  else
    $start = $index - $half;
  
  $end = min($start + $count, count($arr));
  $new = array();
  for ($i = $start; $i < $end; $i++) {
    $new[] = $arr[$i];
  }
  $offset = $start;
  $beginIndex = $index - $start - 1;
  return $new;
}

function parse_attachment ($part, $ref, $msg) {
  global $bodypart, $imp, $index, $default, $lang, $textpart, $images;
  $j = 0;
  
  (isset($part->parts) && is_array($part->parts)) ? $num_parts = count($part->parts) : $num_parts = 1;
  
  while ($j < $num_parts) {
    if (strlen($ref) == 0)
      $aref = '' . ($j+1);
    else
      $aref = $ref . '.' . ($j+1);
    
    if (isset($part->parts[$j]))
      $p = $part->parts[$j];
    else
      $p = $part;
    
    $mime = new mime_part_data;
    $mime->set_imap_data($index, $aref, $imp->mailbox);
    $mime->parse($p);
    // we only display the first text part (we can change it to
    // display all textual parts, separated by <hr>) We do not display
    // text/plain parts with binary or unknown encoding
    if ($mime->type == TYPETEXT && 
	($mime->subtype == 'plain' || $mime->subtype == 'enriched') && 
	$mime->size > 0 &&
	($mime->encoding == ENC7BIT || 
	 $mime->encoding == ENC8BIT || 
	 $mime->encoding == ENCQUOTEDPRINTABLE || 
	 $mime->encoding == ENCBASE64) &&
	($textpart == 0 || $default->text_parts_inline)) {
      
      /* Safe to display, it is text */
      /* get and format the main body part */
      $tmsg = @imap_fetchbody($imp->stream, $index, $aref, FT_UID);
      
      /* If it's a quoted-printable document, translate it into the right charset */
      if ($mime->encoding == ENCQUOTEDPRINTABLE) {
	$tmsg = imap_qprint($tmsg);
      } else if ($mime->encoding == ENCBASE64) {
	$tmsg = imap_base64($tmsg);
      }
      
      $msglen = strlen($tmsg);
      if (strlen($tmsg) > 0) {
	if ($default->max_wrap_size == 0 || $default->max_wrap_size > $msglen) {
	  $tmsg = wrap_message($tmsg, 85);
	}
	$tmsg = preg_replace("|(\\w+)://([^\\s]*)([\\w#?/&=])|", "<a href=\"\\1://\\2\\3\" target=\"_blank\">\\1://\\2\\3</a>", $tmsg);
	$tmsg = preg_replace("|mailto:(\\s?)([\\w/\n+-=%&:_.~@]+[#\\w+]*)|i", "<a href=\"javascript:open_compose_win('actionID=33&to=\\2');\">mailto:\\1\\2</a>", $tmsg);
	$tmsg = preg_replace("|&to:([\\w/\n+-=%&:_.~@]+[#\\w+]*)?subject=([\\w/\n+-=%&:_.~@]+[#\\w+]*)|i", "mailto:\\1&subject=\\2", $tmsg);
	$tmsg = htmlspecialchars($tmsg);
	$tmsg = str_replace('&quot; target=&quot;_blank&quot;&gt;', '" target="_blank">', $tmsg);
	$tmsg = str_replace('&quot;&gt;','">', $tmsg);
	$tmsg = str_replace('\');&quot;&gt;', '\');">', $tmsg);
	$tmsg = str_replace('&lt;a href=&quot;', '<a href="', $tmsg);
	$tmsg = str_replace('&lt;/a&gt;', '</a>', $tmsg);
      }
      $charset = $mime->charset;
      
      if (strtolower($charset) == 'windows-1251') {
        $tmsg = convert_cyr_string($tmsg, 'w', 'k');
      }
      
      if ($textpart > 0) {
	$msg = $msg . '</pre></td></tr><tr><td></td></tr><tr><td bgcolor="' . $default->text_bg . '"><pre>' . $tmsg;
	add_attachment(&$mime, $aref);
      } else {
	$msg = $tmsg;
	if (!isset($bodypart))
	  $bodypart = $aref;
      }
      $textpart++;
      
      /* It may not be text directly, but if its configured to be displayed inline, inline it */
    } else if (isset($mime->action['view']) && 
	       isset($mime->action['inline']) &&
	       ($mime->encoding == ENC7BIT || 
		$mime->encoding == ENC8BIT || 
		$mime->encoding == ENCQUOTEDPRINTABLE || 
		$mime->encoding == ENCBASE64) &&
	       $mime->action['view'] && 
	       $mime->action['inline'] &&
	       isset($mime->action['view_function'])) {
      
      if ($textpart > 0) {
	
	/* If this MIME-type is configured to override other things for display, do it */
	if (isset($mime->action['override_text']) && $mime->action['override_text']) {
	  $msg = '';
	} else {
	  $msg = $msg . '</pre></td></tr><tr><td></td></tr><tr><td bgcolor="' . $default->text_bg . '"><pre>';
	}
	
	eval('$mime_part = ' . $mime->action['view_function'] . '($mime);');
	$msg = $msg . $mime_part;
      } else {
	eval('$mime_part = ' . $mime->action['view_function'] . '($mime);');
	$msg = $msg . $mime_part;
	if (!isset($bodypart))
	  $bodypart = $aref;
      }
      $textpart++;
      
      /* add it as an attachment link to download if this type is downloadable */
      if (isset($mime->action['download']) && $mime->action['download']) {
	add_attachment(&$mime, $aref);
      }
    } else {
      if (!empty($p->id)) $images[$p->id] = $aref;
      add_attachment(&$mime, $aref);
    }
    
    // add children *after* adding the parent part...
    if (isset($p->parts[0])) {
      if ($mime->type == TYPEMULTIPART && (strcmp($mime->subtype, 'report') == 0 || strcmp($mime->subtype, 'mixed') == 0))
	$msg = parse_attachment($p, $ref, $msg);
      else
	$msg = parse_attachment($p, $aref, $msg);
    }
    $j++;
  }
  return $msg;
}


function wrap ($text, $wrap = 80, $break = "\n") {
  $paras = explode("\n", $text);
  
  $result = array();
  $i = 0;
  while ($i < count($paras)) {
    if (strlen($paras[$i]) <= $wrap) {
      $result[] = $paras[$i];
      $i++;
    } else {
      $result[] = substr($paras[$i], 0, $wrap);
      $new = trim(substr($paras[$i], $wrap, strlen($paras[$i]) - $wrap));
      if ($new != '') $paras[$i] = $new;
      else $i++;
    }
  }
  return implode($break, $result);
}


$need_horde_db = 0;
$db_lib_loaded = 0;
if (!defined("HORDE_LIB")) include '../lib/horde.lib';
require './lib/imp.lib';           /* IMPlib is the IMP function library */
require './lib/mimetypes.lib';     /* Mime handling routes */
require './config/defaults.php3';  /* Defaults configuration file */
require './config/html.php3';
require './config/mime.php3';
$language = select_lang();
require "./locale/$language/message.lang";
require './locale/local/message.lang';

error_reporting($default->error_level);

page_open(array('sess' => 'HordeSession'));
if (!isset($imp) || !is_object($imp)) { page_close(); header("Location: login.php3?reason=logout"); exit; }
$imp->unpickle();
$imp->authenticate();
$sorted = explode(':', $imp->msgl);
if ($array_index == count($sorted)-1 || $array_index == 0 || (isset($actionID) && ($actionID == DELETE_MESSAGES || $actionID == MOVE_MESSAGES || $actionID == COPY_MESSAGES) && $array_index == count($sorted)-2)) {
  $sorted = messageRange(imap_sort($imp->stream, $imp->sortby, $imp->sortdir, SE_UID), $array_index + $imp->offset + 1, &$offset, &$array_index);
  $imp->msgl = implode(':', $sorted);
  $imp->offset = $offset;
  $imp->pickle();
}
$msgindex = $array_index + $imp->offset;

require "$default->include_dir/doctype.inc";

/* Run through action handlers */
if (isset($actionID)) {
  switch ($actionID) {
  case NO_ACTION:
    break;
    
  case DELETE_MESSAGES:
    if ($index && $imp->mailbox) {
      if (!(@imap_delete($imp->stream, imap_msgno($imp->stream, $index)))) {
	$errormsg = $lang->delete_error;
	$array_index++;
	$msgindex++;
	$index = $sorted[$array_index];
      } else {
	if ($imp->servtype == 'pop3') {
	  // expunge the mailbox to actually delete the message, and then recalculate the message list
	  imap_expunge($imp->stream);
	  $sorted = messageRange(imap_sort($imp->stream, $imp->sortby, $imp->sortdir, SE_UID), $array_index + $imp->offset + 1, &$offset, &$array_index);
	  $imp->msgl = implode(':', $sorted);
	  $imp->offset = $offset;
	  $imp->pickle();
	  $index = $sorted[$array_index];
	  $msgindex = $array_index + $imp->offset;
	} else {
	  $array_index++;
	  $msgindex++;
	  $index = $sorted[$array_index];
	}
      }
    }
    break;
    
  case MOVE_MESSAGES:
    if (isset($index) && isset($targetMbox) && $index && $targetMbox) {
      if (!(@imap_mail_copy($imp->stream, $index, $targetMbox, CP_UID|CP_MOVE))) {
	$status_string = $lang->move_error;
	$status_color = 'red';
      } else {
	$plural = false;
	$status_string = $lang->success2($imp->label, $targetMbox, 'moved', 1, $plural);
	$status_color = 'green';
	$array_index++;
	$msgindex++;
	$index = $sorted[$array_index];
      }
    }
    if (!isset($status_string)) {
      $plural = false;
      $status_string = $lang->move_error;
      $status_color = 'red';
    }  
    break;
    
  case COPY_MESSAGES:
    if (isset($index) && isset($targetMbox) && $targetMbox && $index) {
      if (!@imap_mail_copy($imp->stream, $index, $targetMbox, CP_UID)) {
	$status_string = $lang->copy_error;
	$status_color = 'red';
      } else {
	$plural = false;
	$status_string = $lang->success2($imp->label, $targetMbox, 'copied', 1, $plural);
	$status_color = 'green';
	$array_index++;
	$msgindex++;
	$index = $sorted[$array_index];
      }
    }
    if (!isset($status_string)) {
      $plural = false;
      $status_string = $lang->copy_error;
      $status_color = 'red';
    }
    break;
  }
}
page_close();

if ($default->user_use_folders) {
  $options = mailbox_list(true);
}

/* parse MIME header info */
$structure = @imap_fetchstructure($imp->stream, imap_msgno($imp->stream, $index));
(isset($structure->parts) && is_array($structure->parts)) ? $num_parts = count($structure->parts) : $num_parts = 1;

if (!isset($bodypart)) $bodypart = 1;
$textpart = 0;
$num = 0;
$msg = '&nbsp;';
$msg = parse_attachment($structure, '', $msg);

// handle multipart/related images. this should ideally go somewhere else, but it works here
if (!empty($images)) {
  while (list($img, $id) = each($images)) {
    if ($img[0] == '<') $img = substr($img, 1);
    if ($img[strlen($img)-1] == '>') $img = substr($img, 0, strlen($img)-1);
    $msg = str_replace("cid:$img", 'view.php3?actionID=' . VIEW_ATTACH . '&index=' . $index . '&mailbox=' . urlencode($imp->mailbox) . '&bodypart=' . $id, $msg);
  }
}

if ($default->view_message_source) {
  if (!isset($atc)) $atc = '';
  $mime = new mime_part_data;
  $mime->set_type_full('message/source');
  $atc .= '<tr><td>' . $mime->img_tag() . '</td><td><font size="2" face="' . $default->font->face . '">' . "<a href=\"javascript:view('" . VIEW_SOURCE . "', 0);\">" . $lang->source . '</a></font></td><td colspan="3">&nbsp;</td></tr>';
}

$h = @imap_header($imp->stream, imap_msgno($imp->stream, $index));

if (isset($h->date))            { $dat = htmlspecialchars(chop($h->date)); }
if (isset($h->toaddress))       { $to  = htmlspecialchars(decode_mime_string(chop($h->toaddress))); }
if (isset($h->fromaddress))     { $frm = htmlspecialchars(decode_mime_string(chop($h->fromaddress))); }
if (isset($h->ccaddress))       { $cc  = htmlspecialchars(decode_mime_string(chop($h->ccaddress))); }
if (isset($h->bccaddress))      { $bcc  = htmlspecialchars(decode_mime_string(chop($h->bccaddress))); }
if (isset($h->reply_toaddress)) { $rep = htmlspecialchars(decode_mime_string(chop($h->reply_toaddress))); }
if ((isset($h->subject)) && (strlen($h->subject) != 0)) {
  $sub = htmlspecialchars(decode_mime_string(chop($h->subject)));
} else {
  $sub = $lang->no_subject;
}

// try and add some space in order to break really long header lines
if (isset($to)) $to = str_replace(',', ', ', $to);
if (isset($cc)) $cc = str_replace(',', ', ', $cc);
if (isset($frm)) $frm = str_replace(',', ', ', $frm);
if (isset($bcc)) $bcc = str_replace(',', ', ', $bcc);
if (isset($rep)) $rep = str_replace(',', ', ', $rep);

$msg_index = $array_index + 1;
$num_msgs = imap_num_msg($imp->stream);

$title = "$imp->label: $sub";
$sidebar = false;
require "$default->include_dir/generic-header.inc";

$prev_index = $array_index - 1;
$next_index = $array_index + 1;

if (isset($sorted[$prev_index])) $prev = $sorted[$prev_index];
else $prev = -1;

if (isset($sorted[$next_index])) $next = $sorted[$next_index];
else $next = -1;

if ($msg_index != count($sorted)) {
   $del_target = 'message.php3';
   $del_ident  = 'index';
} else {
   $del_target = 'mailbox.php3';
   $del_ident  = 'indices';
}

require './lib/js/open_compose_win.js';
require './lib/js/open_contacts.js';
require "$default->include_dir/message/navbar_aux_top.inc";
require "$default->include_dir/message/navbar.inc";
require "$default->include_dir/message/headers.inc";
require "$default->include_dir/message/message.inc";
require "$default->include_dir/message/navbar.inc";
require "$default->include_dir/message/navbar_aux_bottom.inc";
require "$default->include_dir/message/javascript.inc";

if (isset($status_string)) {
  status($status_string, $status_color);
}

require "$default->include_dir/generic-footer.inc";
?>
